Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSFrame.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSFrame.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSFrame.java	(revision 2159)
@@ -20,9 +20,20 @@
 
 
-import javax.swing.*;
-import javax.swing.border.*;
+import javax.swing.JMenuItem;
+import javax.swing.JMenuBar;
+import javax.swing.JPanel;
+import javax.swing.JFrame;
+import javax.swing.JList;
+import javax.swing.JPopupMenu;
+import javax.swing.BoxLayout;
+import javax.swing.JMenu;
+import javax.swing.AbstractAction;
+import javax.swing.SwingUtilities;
+import javax.swing.KeyStroke;
+
 import java.awt.*;
 import java.awt.event.*;
-import java.util.*;
+import java.util.Observer;
+import java.util.Observable;
 /**
  * Class 
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSModel.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSModel.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/CSModel.java	(revision 2159)
@@ -19,6 +19,8 @@
 package org.nzdl.gsdl.SimpleGraphicalClient;
 
-import java.util.*;
-import javax.swing.*;
+import java.util.Set;
+import java.util.TreeSet;
+import java.util.Iterator;
+import java.util.Vector;
 
 // local libraries
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/Result.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/Result.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/Result.java	(revision 2159)
@@ -19,5 +19,4 @@
 package org.nzdl.gsdl.SimpleGraphicalClient;
 
-import java.io.*;
 /**
  * Class 
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/ResultModel.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/ResultModel.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/ResultModel.java	(revision 2159)
@@ -19,7 +19,6 @@
 package org.nzdl.gsdl.SimpleGraphicalClient;
 
-import java.util.*;
 import javax.swing.event.*;
-import javax.swing.*;
+import javax.swing.DefaultListModel;
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SearchPanel.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SearchPanel.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SearchPanel.java	(revision 2159)
@@ -21,8 +21,8 @@
 import java.awt.*;
 import java.awt.event.*;
-import java.io.*;
+import java.io.StringReader;
+import java.io.IOException;
 import java.util.*;
 import javax.swing.*;
-import javax.swing.border.*;
 import javax.swing.event.*;
 import javax.swing.text.*;
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java	(revision 2159)
@@ -21,13 +21,6 @@
 package org.nzdl.gsdl.SimpleGraphicalClient;
 
-import java.awt.*;
-import javax.swing.*;
-import java.util.*;
-import java.io.*;
-import java.net.URL;
-
-// long live GNU ...
-import gnu.getopt.Getopt;
-import gnu.getopt.LongOpt;
+import java.awt.Dimension;
+import java.awt.Toolkit;
 
 // local libraries
@@ -57,8 +50,6 @@
  * @see org.nzdl.gsdl.service.NzdlResultSet
  * @see org.nzdl.gsdl.service.NzdlService
- * @see org.nzdl.gsdl.service.NzdlServiceImpl 
+ * @see org.nzdl.gsdl.service.NzdlServiceClient
  * @see org.nzdl.gsdl.util.NzdlIORs;
- * @see gnu.getopt.Getopt;
- * @see gnu.getopt.LongOpt;
  */
 
@@ -66,8 +57,8 @@
 public class SimpleGraphicalClient implements Cloneable {
 
-	CSModel csModel;
-	CSFrame window;
-	
- 
+  CSModel csModel;
+  CSFrame window;
+  
+  
   /** The underlying CORBA inferface */
   NzdlService nzdl = null;
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlQuery.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlQuery.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlQuery.java	(revision 2159)
@@ -21,5 +21,9 @@
 package org.nzdl.gsdl.service;
 
-import java.util.*;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+import java.util.Collection;
+
 import org.nzdl.gsdl.util.NzdlConstants;
 
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlQueryHit.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlQueryHit.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlQueryHit.java	(revision 2159)
@@ -21,5 +21,7 @@
 package org.nzdl.gsdl.service;
 
-import java.util.*;
+import java.util.Map;
+import java.util.Set;
+import java.util.Collection;
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlRequest.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlRequest.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlRequest.java	(revision 2159)
@@ -21,7 +21,8 @@
 package org.nzdl.gsdl.service;
 
+import java.util.List;
+
 import org.nzdl.gsdl.corba.gsdlInterface.*;
 import org.nzdl.gsdl.util.*;
-import java.util.*;
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlResponse.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlResponse.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlResponse.java	(revision 2159)
@@ -21,5 +21,10 @@
 package org.nzdl.gsdl.service;
 
-import java.util.*;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+import java.util.List;
+import java.util.ArrayList;
 
 import org.nzdl.gsdl.service.*;
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlResultSet.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlResultSet.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlResultSet.java	(revision 2159)
@@ -21,5 +21,11 @@
 package org.nzdl.gsdl.service;
 
-import java.util.*;
+import java.util.Set;
+import java.util.Map;
+import java.util.List;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.ListIterator;
+
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlService.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlService.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlService.java	(revision 2159)
@@ -21,5 +21,7 @@
 package org.nzdl.gsdl.service;
 
-import java.util.*;
+import java.util.Set;
+import java.util.Map;
+import java.util.List;
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlServiceServer.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlServiceServer.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlServiceServer.java	(revision 2159)
@@ -25,11 +25,7 @@
 import java.io.Serializable;
 import java.lang.Cloneable;
-import java.util.*;
-
-// HelloServer will use the naming service.
-import org.omg.CosNaming.*;
-// The package containing special exceptions thrown by the name service.
-//import org.omg.CosNaming.NamingContextPackage.*;
-// All CORBA applications need these classes.
+import java.util.Set;
+import java.util.Iterator;
+
 import org.omg.CORBA.ORB;
 
@@ -46,11 +42,14 @@
 
 /**
- * SimpleServer
- *
- * Based on algorithms in ...
+ * Act as a Server.
+ *
+ * Designed as a mirror image of NzdlServiceClient
  *
  * @author stuart yeates (say1@cs.waikato.ac.nz)
  * @version $Revision$
-
+ * @see org.nzdl.gsdl.service.NzdlService
+ * @see org.nzdl.gsdl.service.NzdlServiceClient
+ * @see org.nzdl.gsdl.service.NzdlServiceWrapper
+ * @see org.nzdl.gsdl.corba.gsdlInterface._corbaifaceImplBase
  * 
  */
@@ -59,14 +58,18 @@
 public class NzdlServiceServer extends _corbaifaceImplBase {
 
+  /** The underlying interface */
   NzdlService nzdl = null;
   
+  /** The normal constructor */
   public NzdlServiceServer(NzdlService service) {
     nzdl = service;
   }
 
-  public NzdlServiceServer() {
+  /** The beans constructor */
+  protected NzdlServiceServer() {
     nzdl = null;
   }
 
+  /** initialisation (not guaranteed to be called ...) */
   public boolean initialise (corbaComErrorHolder error) {
     // TODO should map the anything in NzdlService?
@@ -76,4 +79,10 @@
     return true;
   }
+  
+  /**
+   * Allow the client to configure a CORBA server.
+   * @param key the parameter to be set.
+   * @param values what that parameter will be set to.
+   */
   public void configure (corbatext_t key, 
 			 corbatext_t[] cfgline,
@@ -87,4 +96,10 @@
   }
 
+
+  /**
+   * Obtain the set of collection names for a Greenstone library.
+   * @param collist A set of collection names in string format.
+   * @param error a corba error object
+   */
   public void collectionList (corbatext_tarrayHolder collist,
 			      corbaComErrorHolder error) {
@@ -108,4 +123,9 @@
     return;
   }
+  /**
+   * Does the server have a specific collections? 
+   * @param has a boolean
+   * @param error a corba error object
+   */
   public void hasCollection (corbatext_t corbaCollection,
 			     org.omg.CORBA.BooleanHolder has, 
@@ -122,4 +142,10 @@
     return;
   }
+  /**
+   * Is the collection avalibale for use?
+   * @param error a corba error object
+   * @return <tt>true</tt> if the collection is avaliable, 
+   *    <tt>false</tt> otherwise
+   */
   public boolean ping (corbatext_t collection, 
 		       corbaComErrorHolder error) {
@@ -127,4 +153,12 @@
     return  nzdl.hasCollection(name);
   }
+
+  /**
+   * Get a document
+   * @param collection the collection the document is in
+   * @param request the details of the document
+   * @param response the document
+   * @param error a corba error object
+   */
   public void getDocument (corbatext_t collection, 
 			   corbaDocRequestHolder request, 
Index: trunk/java-client/org/nzdl/gsdl/util/NzdlCorbaFactory.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/util/NzdlCorbaFactory.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/util/NzdlCorbaFactory.java	(revision 2159)
@@ -21,5 +21,9 @@
 package org.nzdl.gsdl.util;
 
-import java.util.*;
+import java.util.Set;
+import java.util.HashSet;
+import java.util.List;
+import java.util.ListIterator;
+
 import org.nzdl.gsdl.service.NzdlQuery;
 import org.nzdl.gsdl.corba.gsdlInterface.*;
Index: trunk/java-client/org/nzdl/gsdl/util/NzdlHosts.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/util/NzdlHosts.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/util/NzdlHosts.java	(revision 2159)
@@ -35,7 +35,7 @@
 import org.omg.CORBA.Object;
 import org.omg.CORBA.ORB;
-import org.nzdl.gsdl.service.*;
 import java.net.URL;
 
+import org.nzdl.gsdl.service.*;
 
 /**
Index: trunk/java-client/org/nzdl/gsdl/util/NzdlIORs.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/util/NzdlIORs.java	(revision 2158)
+++ trunk/java-client/org/nzdl/gsdl/util/NzdlIORs.java	(revision 2159)
@@ -20,8 +20,4 @@
 // the package we're in
 package org.nzdl.gsdl.util;
-
-// long live GNU ...
-import gnu.getopt.Getopt;
-import gnu.getopt.LongOpt;
 
 // java libraries we're using