Index: trunk/java-client/org/nzdl/gsdl/SimpleClient.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleClient.java	(revision 2178)
+++ trunk/java-client/org/nzdl/gsdl/SimpleClient.java	(revision 2179)
@@ -55,5 +55,5 @@
 import org.nzdl.gsdl.service.NzdlService;
 import org.nzdl.gsdl.service.NzdlServiceClient;
-import org.nzdl.gsdl.util.NzdlIORs;
+import org.nzdl.gsdl.util.NzdlServiceFactory;
 
 /**
@@ -111,5 +111,5 @@
    */ 
   protected SimpleClient() {
-    nzdl = NzdlIORs.createNzdlService(null, 
+    nzdl = NzdlServiceFactory.createNzdlService(null, 
 				      System.getProperties(), 
 				      URLFromCommandLine,
@@ -126,5 +126,5 @@
   SimpleClient(String [] args) {
     parseArgs(args);
-    nzdl = NzdlIORs.createNzdlService(args, 
+    nzdl = NzdlServiceFactory.createNzdlService(args, 
 				      System.getProperties(), 
 				      URLFromCommandLine, 
Index: trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java	(revision 2178)
+++ trunk/java-client/org/nzdl/gsdl/SimpleGraphicalClient/SimpleGraphicalClient.java	(revision 2179)
@@ -32,5 +32,5 @@
 import org.nzdl.gsdl.service.NzdlService;
 import org.nzdl.gsdl.service.NzdlServiceClient;
-import org.nzdl.gsdl.util.NzdlIORs;
+import org.nzdl.gsdl.util.NzdlServiceFactory;
 
 /**
@@ -51,5 +51,5 @@
  * @see org.nzdl.gsdl.service.NzdlService
  * @see org.nzdl.gsdl.service.NzdlServiceClient
- * @see org.nzdl.gsdl.util.NzdlIORs;
+ * @see org.nzdl.gsdl.util.NzdlServiceFactory;
  */
 
@@ -95,5 +95,5 @@
    */
     void init(String [] args)  {
-	nzdl = NzdlIORs.createNzdlService(args, 
+	nzdl = NzdlServiceFactory.createNzdlService(args, 
 					  System.getProperties(), 
 					  null,
Index: trunk/java-client/org/nzdl/gsdl/SimpleServer.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/SimpleServer.java	(revision 2178)
+++ trunk/java-client/org/nzdl/gsdl/SimpleServer.java	(revision 2179)
@@ -39,5 +39,5 @@
 import org.nzdl.gsdl.service.NzdlServiceClient;
 import org.nzdl.gsdl.util.NzdlCorbaFactory;
-import org.nzdl.gsdl.util.NzdlIORs;
+import org.nzdl.gsdl.util.NzdlServiceFactory;
 
 
@@ -69,5 +69,9 @@
     corbaComErrorHolder error = NzdlCorbaFactory.createComErrorHolder();
     try{
-      SimpleClient client = new SimpleClient();
+      NzdlServiceFactory.caching = true;
+      NzdlServiceFactory.doMultiple = true;
+      NzdlServiceFactory.saveDocs = true;
+      
+      NzdlServiceClient client = NzdlServiceFactory.createNzdlService();
     
       ORB orb = ORB.init(args, null);
@@ -84,5 +88,5 @@
       System.err.println(orb.object_to_string(simpleRef));     
      
-      NzdlIORs.registerIOR(orb.object_to_string(simpleRef));
+      NzdlServiceFactory.registerIOR(orb.object_to_string(simpleRef));
 
       try  {
@@ -111,2 +115,8 @@
   }
 }
+
+
+
+
+
+
Index: trunk/java-client/org/nzdl/gsdl/service/NzdlCollectionInfo.java
===================================================================
--- trunk/java-client/org/nzdl/gsdl/service/NzdlCollectionInfo.java	(revision 2178)
+++ trunk/java-client/org/nzdl/gsdl/service/NzdlCollectionInfo.java	(revision 2179)
@@ -46,4 +46,8 @@
   public NzdlCollectionInfo( corbaColInfoResponse _info ) {
     m_Info = _info;
+    if (!getHTTPDomain().equals(""))
+      System.out.println("getHTTPDomain working !");
+    if (!getName().equals(""))
+      System.out.println("getName working !");
   }
 
Index: trunk/java-client/org/nzdl/gsdl/util/Makefile
===================================================================
--- trunk/java-client/org/nzdl/gsdl/util/Makefile	(revision 2178)
+++ trunk/java-client/org/nzdl/gsdl/util/Makefile	(revision 2179)
@@ -16,5 +16,5 @@
      NzdlCorbaFactory.class  \
      NzdlHosts.class  \
-     NzdlIORs.class
+     NzdlServiceFactory.class
 
 all: $(CLASSFILES)